' Simple tone maker for Parallax Propeller BOE board
' Speaker output(s) are on pins 26 and 26
' See code.google.com/p/gravitydevelopmentboard/ for a more
'   in-depth version that also plays canned songs. Be sure
'   to modify the output pin accordingly. Use pin 26 or pin 27.

OBJ

  FloatMath  :  "FloatMath"    'Part of Propeller Tool

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  OutPin = 27         ' Left speaker output  
  
PUB Go

  repeat 3            ' Repeat 3 times
    Tone(33,   325)   'C1  
    Tone(65,   500)   'C2
    Tone(131,  200)   'C3
    Tone(262,  750)   'C4
    Tone(523,  150)   'C5
    Tone(1047, 450)   'C6
    Tone(2093, 90)    'C7

    'Frequency, Duration  

PUB Tone(Hz, Duration) | Delay, Ticks, Count

  DIRA[OutPin]~~
  OUTA[OutPin] := 1
  
  Delay := Hz * 2
  Ticks := FloatMath.fmul(Hz, FloatMath.fdiv(Duration, 1000))

  repeat Count from 0 to (2 * Ticks)
    !OUTA[OutPin]
    waitcnt(clkfreq / Delay + cnt)